#!/usr/bin/env python3
presets = [ # sorted by how fast the car is
	"CS_CAR_33", # PUNTO
	"CS_CAR_14", # COBALTSS
	"CS_CAR_35", # CAMARO
	"CS_CAR_12", # IS300
	"CS_CAR_06", # ECLIPSEGT
	"CS_CAR_09", # CTS
	"CS_CAR_01", # GTI
	"CS_CAR_13", # CLIO
	"CS_CAR_03", # GTO
	"CS_CAR_31", # MONARO
	"CS_CAR_02", # RX8
	"CS_CAR_08", # IMPREZAWRX
	"CS_CAR_28", # LANCEREVO8
	"CS_CAR_07", # SUPRA
	"CS_CAR_17", # RX7
	"CS_CAR_32", # CLK500
	"CS_CAR_05", # CORVETTE
	"CS_CAR_11", # VIPER
	"CS_CAR_27", # SL500
	"CS_CAR_30", # CAYMANS
	"CS_CAR_04", # 997S
	"CS_CAR_26", # ELISE
	"CS_CAR_15", # 911TURBO
	"CS_CAR_16", # DB9
	"CS_CAR_20", # SLR
	"CS_CAR_10", # GALLARDO
	"CS_CAR_34", # GALLARDO
	"CS_CAR_18", # MURCIELAGO
	"CS_CAR_19", # CARRERAGT
	"CS_CAR_29"  # CORVETTEC6R
]

maxVariation = 4 # How far back/forward will be looked in the preset-list to pick a car, relative to the blacklist placement. This needs to be equal or higher to the amonut of characters
seed = 1337 # The seed to generate randomness with. The same seed always results in the same result.

characters = """\
update_field gameplay race_bin_01/character1 CollectionName race_bin_01/character1
update_field gameplay race_bin_01/character2 CollectionName race_bin_01/character2
update_field gameplay race_bin_01/character3 CollectionName race_bin_01/character3
update_field gameplay race_bin_02/character1 CollectionName race_bin_02/character1
update_field gameplay race_bin_02/character2 CollectionName race_bin_02/character2
update_field gameplay race_bin_02/character3 CollectionName race_bin_02/character3
update_field gameplay race_bin_03/character1 CollectionName race_bin_03/character1
update_field gameplay race_bin_03/character2 CollectionName race_bin_03/character2
update_field gameplay race_bin_03/character3 CollectionName race_bin_03/character3
update_field gameplay race_bin_04/character1 CollectionName race_bin_04/character1
update_field gameplay race_bin_04/character2 CollectionName race_bin_04/character2
update_field gameplay race_bin_04/character3 CollectionName race_bin_04/character3
update_field gameplay race_bin_04/drag_opponent CollectionName race_bin_04/drag_opponent
update_field gameplay race_bin_05/character1 CollectionName race_bin_05/character1
update_field gameplay race_bin_05/character2 CollectionName race_bin_05/character2
update_field gameplay race_bin_05/character3 CollectionName race_bin_05/character3
update_field gameplay race_bin_05/drag_opponent CollectionName race_bin_05/drag_opponent
update_field gameplay race_bin_06/character1 CollectionName race_bin_06/character1
update_field gameplay race_bin_06/character2 CollectionName race_bin_06/character2
update_field gameplay race_bin_06/character3 CollectionName race_bin_06/character3
update_field gameplay race_bin_06/drag_opponent CollectionName race_bin_06/drag_opponent
update_field gameplay race_bin_07/character1 CollectionName race_bin_07/character1
update_field gameplay race_bin_07/character2 CollectionName race_bin_07/character2
update_field gameplay race_bin_07/character3 CollectionName race_bin_07/character3
update_field gameplay race_bin_07/drag_opponent CollectionName race_bin_07/drag_opponent
update_field gameplay race_bin_08/character1 CollectionName race_bin_08/character1
update_field gameplay race_bin_08/character2 CollectionName race_bin_08/character2
update_field gameplay race_bin_08/character3 CollectionName race_bin_08/character3
update_field gameplay race_bin_08/drag_opponent CollectionName race_bin_08/drag_opponent
update_field gameplay race_bin_09/character1 CollectionName race_bin_09/character1
update_field gameplay race_bin_09/character2 CollectionName race_bin_09/character2
update_field gameplay race_bin_09/character3 CollectionName race_bin_09/character3
update_field gameplay race_bin_09/drag_opponent CollectionName race_bin_09/drag_opponent
update_field gameplay race_bin_10/character1 CollectionName race_bin_10/character1
update_field gameplay race_bin_10/character2 CollectionName race_bin_10/character2
update_field gameplay race_bin_10/character3 CollectionName race_bin_10/character3
update_field gameplay race_bin_10/drag_opponent CollectionName race_bin_10/drag_opponent
update_field gameplay race_bin_11/character1 CollectionName race_bin_11/character1
update_field gameplay race_bin_11/character2 CollectionName race_bin_11/character2
update_field gameplay race_bin_11/character3 CollectionName race_bin_11/character3
update_field gameplay race_bin_11/drag_opponent CollectionName race_bin_11/drag_opponent
update_field gameplay race_bin_12/character1 CollectionName race_bin_12/character1
update_field gameplay race_bin_12/character2 CollectionName race_bin_12/character2
update_field gameplay race_bin_12/character3 CollectionName race_bin_12/character3
update_field gameplay race_bin_12/drag_opponent CollectionName race_bin_12/drag_opponent
update_field gameplay race_bin_13/character1 CollectionName race_bin_13/character1
update_field gameplay race_bin_13/character2 CollectionName race_bin_13/character2
update_field gameplay race_bin_13/character3 CollectionName race_bin_13/character3
update_field gameplay race_bin_14/character1 CollectionName race_bin_14/character1
update_field gameplay race_bin_14/character2 CollectionName race_bin_14/character2
update_field gameplay race_bin_14/character3 CollectionName race_bin_14/character3
update_field gameplay race_bin_15/opponent1 CollectionName race_bin_15/opponent1
update_field gameplay race_bin_15/opponent2 CollectionName race_bin_15/opponent2
update_field gameplay race_bin_15/opponent3 CollectionName race_bin_15/opponent3\
"""

import math
import random
random.seed(seed)
charactersProcessed = {}
for line in characters.split("\n"):
	line = line.split(" ")
	racebin = line[2].split("/")[0]
	racer = line[2].split("/")[1]
	if not racebin in charactersProcessed: charactersProcessed[racebin] = []
	charactersProcessed[racebin].append(racer)

output = ""
presets.reverse()
presetToRacebinRatio = len(presets) / len(charactersProcessed)

count = 0
for racebin in charactersProcessed:
	startIndex = presetToRacebinRatio * 10
	vehicles = []
	for character in charactersProcessed[racebin]:
		while True:
			vehicle = math.floor(presetToRacebinRatio * count) + random.randrange(0 - maxVariation,maxVariation)
			if vehicle < 0: continue
			if vehicle >= len(presets): continue
			vehicle = presets[vehicle]
			if character != "drag_opponent":
				if vehicle in vehicles: continue
				vehicles.append(vehicle)
			output = output + "add_field gameplay " +racebin+ "/" +character+ " PresetRide\n"
			output = output + "update_field gameplay " +racebin+ "/" +character+ " PresetRide " +vehicle+ "\n"
			break
	count = count + 1

file = open(__file__.replace(".py",".nfsms"),"w")
file.write(output)
file.close()